This is a single changelog for all published Cognite Data Fusion API bundles (stable, beta, and alpha). Entries are tagged by release channel.
Data Modeling API
Added- New debug notice
intractableCursorWithNestedFilter(grade D, warning): emitted when a query supplies both a cursor and a nested filter on the same result set expression. The additional join required by the nested filter can prevent efficient index-backed pagination.
Cognite Functions
Added- Added functionsAcl:RUN action, which grants permission to call functions without the ability to create or delete them. functionsAcl:WRITE continues to include call access in addition to create and delete permissions.
Streams and Records API
ChangedStricter validation in aggregate records request:- Aggregate identifiers can no longer contain the
.character. - Values
_countand_bucket_countcan no longer be used as aggregate identifiers. - Duplicate aggregate identifiers within the aggregate tree are no longer allowed.
Data Modeling API
Changed- Added
EnumPropertytoRecordContainerPropertyTypeDefinition, enabling enum properties in containers withusedForset torecord. - Updated the supported storage types description for record container properties to include
enum.
Streams and Records API
Changed- Fixed maximum number of active streams created from
BasicLiveDatatemplate to match what we actually allow.
Data Workflows
Added- Added new
functionApptask type, enabling workflows to invoke HTTP endpoints on Cognite Function Apps. Supports built-in system paths (e.g./__health__,/__routes__) and user-defined routes.
Transformations
AddedAddedautoCreate field to ViewDataSource and DataModelSource destination configurations for transformations. The autoCreate field accepts an AutoCreateOptions object with three boolean properties:startNodes: Controls automatic creation of missing start nodes when creating edges (default: true)endNodes: Controls automatic creation of missing end nodes when creating edges (default: true)directRelations: Controls automatic creation of missing direct relation targets (default: true) When set to false, the transformation will validate node/relation references and return a 400 error if referenced instances do not exist.
3D API
Deprecated- Deprecated
ContextualizeImage360AnnotationBodyandDeleteContextualizedImage360AnnotationsBodyrequest bodies for the 360 image contextualization endpoints. These will be removed before the endpoints are released. Use the RC (Release Candidate) variants (ContextualizeImage360AnnotationRCBodyandDeleteContextualizedImage360AnnotationsRCBody) instead.
Agent APIs
Added- New OpenAI models:
azure/gpt-5.2,azure/gpt-5.4
Agent APIs
Added- Added
streamparameter toAgentSessionRequestto enable progress message streaming.
Data Modeling API
AddedAdded 3 new endpoints to trigger revalidation of failed constraints or indexes./models/containers/constraints/retryfor container-level constraints (requires,uniqueness)/models/containers/indexes/retryfor indexes/models/containers/properties/retryfor property-level constraints (nullable,maxListSize,maxTextSize)
Data Workflows
Added- Added
maxConcurrentExecutionsfield to workflows to limit concurrent executions.
3D API
Added- Added (beta) documentation for a new
/3d/contextualization/cadendpoint, for contextualization of CAD nodes and asset instanceIds in DataModelOnly projects. This endpoint is preferred over the legacy/3d/models/{modelId}/revisions/{revisionId}/mappingsendpoint.
Data Workflows
Added- Added
parentTaskExternalIdfield toTaskExecutionschema to identify the parent task for tasks within dynamic tasks or subworkflows. The field is null for top-level tasks.
3D API
Added- Added (beta) documentation for the optional
pipelineConfigurationproperty for the 3D API create revision endpoint, for point cloud processing in Hybrid CDF projects. The settings within that property controls opt-in point cloud processing steps such as 360-images extraction, point cloud classification and point cloud volume suggestions.
Data Workflows
Added- Added
/workflows/triggers/{triggerExternalId}/pauseendpoint to pause triggers. A paused trigger will not create new workflow executions until resumed. - Added
/workflows/triggers/{triggerExternalId}/resumeendpoint to resume a previously paused trigger.
Data Modeling API
Added- Added
recordvalue that can be specified for the container’susedForproperty
Agent APIs
Added- Within Agent CRUD requests, under the agent objects
toolssection, a description of each tool is now rendered above the selectedtypethat explains what the tool is about.
3D API
Added- Added more detailed documentation for the OptimizerJob type in the 3d/jobs endpoint, especially configuration for Point cloud processing. This will be available as Beta documentation.
Hosted extractors API
AddedAddedauthCertificate to REST sources.Deprecated- Deprecated eventhub
keyNameandkeyValuein favor ofauthentication.usernameandpasswordwith basic authentication replaces the old fields. This is to make room for other forms of authentication.
Agent APIs
Added- Added
runtimeVersionfield to agent creation, update, and response schemas. The runtime version defines the complete execution environment including system prompt, available tools, and core features. Defaults to version 1.0.2. - Added
examineDataSemantically(alpha) to the list of available tools for agents. - Added new AWS model:
aws/claude-4.5-sonnet.
Simulator integration API
Added- Added
kindfield to simulator routines and routine revisions (beta) to classify routines by size and complexity; uselongfor routines that require more inputs, outputs, and script steps than usual. - Added
kindfilter to the simulator routines list endpoint (POST /simulators/routines/list) and routine revisions list endpoint (POST /simulators/routines/revisions/list), allowing filtering of routines by kind. In the revisions listing (POST /simulators/routines/revisions/list),includeAllFields=truereturns all fields but omits ‘long’ routines and cannot be combined with thekindfilter.
3D API
AddedAdded 3D API endpoints to create and delete image 360 contextualization connections to CogniteAsset instances. These endpoints are only available in DataModelOnly projects. Currently available in betaPOST /3d/contextualization/image360define image360 contextualizations towards assetsPOST /3d/contextualization/image360/deleteremove image360 contextualizations towards assets
Streams and Records API
Changed- Changed format of partial success response for record ingest, upsert and delete operations.
Simulator integration API
- Added
simulatorExternalIdsfilter to the simulator model revisions list endpoint (POST /simulators/models/revisions/list), allowing filtering of model revisions by simulator external IDs.
Streams and Records API
AddedThe Streams and Records API is now in General Availability (GA).The following endpoints are now available:POST /streamsto create a stream.DELETE /streams/{streamId}to delete a stream.GET /streamsto list all streams.GET /streams/{streamId}to retrieve a specific stream.POST /streams/{streamId}/recordsto create new records into a stream.POST /streams/{streamId}/records/upsertto create new or update existing records in a mutable stream.POST /streams/{streamId}/records/deleteto delete records in a mutable stream.POST /streams/{streamId}/records/filterto retrieve records from a stream.POST /streams/{streamId}/records/syncto sync records from a stream.POST /streams/{streamId}/records/aggregateto aggregate record data from a stream.
Simulator integration API
Added- Added
simulatorExternalIdsfilter to the simulator routines list endpoint (POST /simulators/routines/list), allowing filtering of routines by simulator external IDs. - Added support for simulator routines aggregation (
POST /simulators/routines/aggregate)
Agents API
Added- Added support for interactive message types in the Agent API, enabling bidirectional communication between agents and clients. Agents can now request clients to execute actions, and clients can respond with action messages containing the results.
Cognite Functions
Removed- Python 3.9 (py39) is no longer supported as a runtime argument for Cognite functions.
Agent APIs
- Gemini 2.0 Flash and Claude 3 Haiku have been retired as model options.
Data Modeling API
Added- Added
statefield to constraints returned from the service, describing whether the constraint is validated or failed. - Added
statefield to indexes returned from the service, describing whether the index is successfully built, or if building failed. - Added fields
maxListSizeandmaxTextSizeto theconstraintStatefield in properties returned from the service, describing whether the associated property-level constraints are valdiated or failed.
Agent APIs
DeprecatedagentId in the /ai/agents/chat endpoint has been deprecated in favor of agentExternalId. agentId will be retired from 2025-11-29.Removed- Gemini 1.5 Pro and Gemini 1.5 Flash have been retired as model options.
Time Series API
Changed- Increased the maximum length of string data points from 255 characters to 1023 bytes (UTF-8 encoded).
Data Modeling API
Added- Added field
constraintStateto properties returned from the service, describing the state of any property-level constraints. Currently includes the fieldnullabilitywhich tracks the state of any non-null constraint.
Default runtime in Cognite functions
Changed- Default Python runtime in Cognite functions has been updated from Python 3.11 (py311) to Python 3.12 (py312).
Data Modeling API
Added- Added a
debugparameter to the/models/instances/query,/models/instances/sync, and/models/instances/listendpoints. - The feature returns
noticesproviding insights into query execution, which can be used for performance analysis and optimization.
Data sets API
Fixed- Add length constraints on
nameanddescriptionfields for thePOST /datasets/updateendpoint to disallow empty strings.
3D API
AddedAdded 3D API endpoints to create and delete point cloud volume contextualization connections to CogniteAsset instances. These endpoints are only available in DataModelOnly projects. Currently available in beta.POST /3d/contextualization/pointcloudPOST /3d/contextualization/pointcloud/delete
Agent APIs
Added- New OpenAI models:
azure/o3,azure/o4-mini,azure/gpt-4.1,azure/gpt-4.1-nano,azure/gpt-4.1-mini,azure/gpt-5,azure/gpt-5-mini,azure/gpt-5-nano - New Gemini models:
gcp/gemini-2.5-pro,gcp/gemini-2.5-flash - New AWS models:
aws/claude-4-sonnet,aws/claude-4-opus,aws/claude-4.1-opus
- Various improvements to the Agent APIs after feedback from the initial alpha release. The Agent APIs (
/ai/agents) to programmatically build and interact with Atlas agents are now in beta state.
Simulator integration API
Changed- Introduced limits for number of simulator nodes and edges in a simulator model revision flowsheet, as well as number of properties per node. (Alpha feature)
- Support multiple flowsheets in a simulator model revision data. (Alpha feature)
IAM (Identity and access management)
AddedThe following endpoints (all under https://auth.cognite.com) are added:/api/v1/orgs/{org}/principals/{principal}/sessions: List login sessions for a user principal in an organization./api/v1/orgs/{org}/principals/{principal}/sessions/revoke: Revoke one or more login sessions for a user principal in an organization.
3D API
Added- Added support in the create 3D asset mappings endpoint for creating asset mappings for 3D CAD
nodeIdand CogniteAssetassetInstanceIdpairs. This creates connections between instances in data modelling and 3D CAD nodes. Only available in Hybrid and DMSFirst CDF projects. - Added support in the list 3D asset mappings endpoint for listing
assetInstanceIdbased mappings, enabled with thegetDmsInstances=trueparameter.
Data Modeling API
AddedAddedmode to table expressions in the /sync endpoint, to select between sync modes:onePhase(default, current behavior): All instances are returned while following the cursortwoPhase: Existing instances are returned first, then new instances are returned by following the cursornoBackfill: Existing instances are not returned, only new instances are yielded by following the cursor.
Data Modeling API
Added- Added
backfillSortto table expressions in the/syncendpoint, to optionally specify how to sort existing instances withsyncMode: twoPhase. - Add
timezoneproperty to the/triggerendpoint.
IAM (Identity and access management)
Added- Added
attributesto group creation in the POST/api/v1/projects/:project/groupsendpoint to set attributes for groups.
Simulator integration API
Changed- Introduced request body size limits for the simulator integration API endpoints.
POST /simulators/routines/revisionsto create simulator routines revisions: 50KBPOST /simulators/runto run a simulation: 50KB- In addition, the simulator connector won’t be able to send more than 100KB of data in a single run. See the Simulator integration API documentation for more details.
Simulator integration API
Changed- The API now accepts empty strings for simulation values (inputs and outputs). Previous restriction on “STRING” values to have a minimum length of 1 character has been removed.
3D API
Added- The 3D API now supports filtering nodes within a boundingbox in dm-only projects.
- The following endpoint is now available:
POST /3d/nodes/listto filter nodes within an area definition.
- The following endpoint is now available:
3D API
Added- The 3D Jobs API is extended to include the job result and job result rejections endpoints.
- The following endpoints are now available:
POST /3d/job/results/listto list the results of a jobPOST /3d/job/result/rejectionsto add or remove job result rejectionsPOST /3d/job/result/rejections/listto list job result rejections
- The following endpoints are now available:
3D API
Added- The 3D Jobs API is now available in DM-Only Projects
- The following endpoints are now available:
POST /3d/jobsto create a 3d jobPOST /3d/jobs/listto list jobsPOST /3d/jobs/deleteto delete jobs
- The following endpoints are now available:
Entity Matching
Changed- Enforcement of request limits.
POST /context/entitymatching/byidscan retrieve max 1000 models per request.POST /context/entitymatching/updatecan update max 1000 models per request.POST /context/entitymatching/deletecan delete max 1000 models per request.
Agents API
Added- The Agents API is now available in Alpha.
- The following endpoints are now available:
POST /ai/agentsto create or update one or more agentsGET /ai/agentsto list all agentsPOST /ai/agents/idsto retrieve one or more agents by externalIdPOST /ai/agents/deleteto delete one or more agents by externalIdPOST /ai/agents/chatto send messages new messages and receive an answer to a specific agent
- The following endpoints are now available:
Documents AI
Added- A new field for specifying the language that the answer should be in, added to Documents Summarize endpoint (
/ai/tools/documents/summarize).
Documents API
Added- Added ability to filter on the
spaceandexternalIdproperties of aninstanceIdobject.
Time Series API
Added- New aggregates
maxDatapointandminDatapoint, that gives back both the value and the timestamp of the maximum/minimum data point.
PostgreSQL Gateway API
Added- The PostgreSQL Gateway API is now in General Availability (GA).
- The following endpoints are now available:
POST /postgresgatewayto create postgres users.POST /postgresgateway/deleteto delete postgres users.POST /postgresgateway/listto filter postgres users.GET /postgresgatewayto list postgres users.POST /postgresgateway/byidsto retrieve postgres users by their username.POST /postgresgateway/updateto update postgres users.POST /postgresgateway/tables/{username}to create postgres foreign tables.POST /postgresgateway/tables/{username}/deleteto delete postgres foreign tables.GET /postgresgateway/tables/{username}to list postgres foreign tables.POST /postgresgateway/tables/{username}/byidsto retrieve postgres foreign tables by name.
- The following endpoints are now available:
Principals API
Added- The Principals API is now generally available.
- The User profiles API is deprecated in favor of the Principals API, which offers a superset of the functionality. The User profiles API will be removed in a future release.
SAP Writeback API
Added- SAP writeback API reaches General Availability (GA).
- The following endpoints are now available:
GET /writeback/sap/instancesto list SAP instance destinationsPOST /writeback/sap/instancesto create SAP instance destinationsPOST /writeback/sap/instances/deleteto delete SAP instance destinationsPOST /writeback/sap/instances/byidsto retrieve SAP instance destinations by externalIdGET /writeback/sap/endpointsto list SAP endpoint destinationsPOST /writeback/sap/endpointsto create SAP endpoint destinationsPOST /writeback/sap/endpoints/deleteto delete SAP endpoint destinationsPOST /writeback/sap/endpoints/byidsto retrieve SAP instance destinations by externalIdPOST /writeback/sap/endpoints/verifyto verify connectivity between CDF and the SAP endpoint destinationGET /writeback/sap/mappingsto list schema mappingsPOST /writeback/sap/mappingsto create schema mappingsPOST /writeback/sap/mappings/deleteto delete schema mappingsPOST /writeback/sap/mappings/byidsto retrieve schema mappings destinations by externalIdGET /writeback/sap/requeststo list writeback requestsPOST /writeback/sap/requeststo create writeback requests. Maximum concurrent limit of 50 requests per CDF project.POST /writeback/sap/requests/byidsto retrieve writeback requests by externalId
- The following endpoints are now available:
User profiles
Added- Organization principals: get calling principal’s profile
GET /api/v1/{projectName}/profiles/meis deprecated in favor of the new endpoint.
Organizations and Projects
UpdatedGET /api/v1/orgs/{org}/projects?includeAdminProperties=truenow includesstateanddeletionTime
Hosted Extractors API
Added- Stabilized the API for
Sources,Mappings,DestinationsandJobs, for MQTT and Kafka extractors. - Promote Rest and EventHub extractors to public beta.
- Support data models in hosted extractors.
AWS Cognito support
Added- Support creating organization with AWS Cognito as IdP.
POST /api/v1/orgs/{orgId}/orgscan be called to create organization with AWS Cognito as IdP.
Organizations and Projects
Added- Allow non-admin users to list all projects in an organization.
GET /api/v1/orgs/{orgId}/projectscan be called by all users of an organization.
- Include
apiUrlwhen listing projects in an organization.GET /api/v1/orgs/{orgId}/projectswill includeapiUrlfor each project.
Time Series API
Added- Introduced support for time series managed by Data modeling in data point subscriptions.
GET subscriptions/memberscan contain members withinstanceId.POST subscriptionscan be used to create subscriptions with an defined set of instance ids.POST subscriptions/updatecan be used to add/remove/set the instance id time series members.
Contextualization / Vision
Added- Support for Vision endpoints referencing files by data modeling instance IDs, as an alternative to ID and external ID.
Simulator integration API
Added- The simulator integration API endpoints have now been promoted to public beta. The following is just a brief list of endpoints. Go to the Cognite API reference documentation (beta) to view all endpoints and their functionalities.
POST /simulators/*to access the simulators API and list simulators enabled for the projectPOST /simulators/integrations/*to list simulator connectors and their statePOST /simulators/models/*to create/list/remove simulator models and their revisionsPOST /simulators/routines/*to create/list/remove simulator routines and their revisionsPOST /simulators/runs/*to create/schedule simulation runsPOST /simulators/logs/*to access simulator logs
Contextualization / Engineering diagrams
Added- Support for detecting tags in diagrams referencing files by data modelling instance ids as an alternative to id and externalId.
Files API
Added- Introduces support for Files managed by Data modeling, which means following endpoints will allow specifying instance Id
POST /files/uploadlinkto get upload links for filesPOST /files/multiuploadlinkto get multipart upload link for filesPOST /files/completemultipartuploadto complete a multipart file uploadPOST /files/downloadlinkto get download links for filesGET /files/iconto get an image representation of a filePOST /files/byidsto retrieve metadata information about multiple specific filesPOST /files/updateto updates the information for the files
Data Workflows
Added- subworkflow task: add support for referencing other workflow versions to run as part of a workflow
Data Workflows
Added- Introduces the trigger resource for Data Workflows, which adds support for scheduling the execution of workflows and the management thereof.
POST /workflows/triggersto create a UNIX cron trigger for a workflowGET /workflows/triggersto list all triggersPOST /workflows/triggers/deleteto delete a triggerGET /workflows/triggers/{triggerExternalId}/historywhich keeps a ledger of when the trigger fired and if it successfully started a workflow or not.
Organizations and Projects
Added- Selected endpoints are promoted from beta to v1 (all under https://auth.cognite.com; note that the routes are
different from the beta routes, and that some request and response signatures have changed):
GET /api/v1/orgs/{orgId}to get organization infoPOST /api/v1/orgs/{orgId}/orgsto create an organizationPOST /api/v1/orgs/{orgId}/deleteto delete an organizationGET /api/v1/orgs/{orgId}/orgsto list the child organizations of an organizationPOST /api/v1/orgs/{orgId}/projectsto create a project in an organizationGET /api/v1/orgs/{orgId}/projectsto list the projects in an organization
- The six beta endpoints that have been published as new V1 endpoints (just above) are deprecated and will be removed in a future release.
Data Modeling
Added- Support for creating properties of type
direct_relation[], allowing direct relations to point to multiple nodes. - /containers/inspect endpoint to retrieve information about which views map a container.
- /instances/inspect endpoint to retrieve information about which containers an instance has data in.
Organizations and Projects
Added- Projects API (Beta): Allow for parametrization of the initial admin group when creating a project.
Time Series
Added- Time zone aware aggregate queries. Align aggregates with a given time zone. Also works with half-hour offsets like Asia/Kolkata (UTC+5:30). Takes DST transitions into account.
- New
month(mo) granularity. - Also applies to synthetic time series.
Organizations and Projects
Added- Organizations API (Beta): create, list, and delete CDF organizations
- Organizations API (Alpha): update CDF organizations
- Projects API (Beta): create and list projects in CDF organizations
User profiles
Added- Organization user profiles (Beta): list users in CDF organizations
Projects
Removed- Removed the previous Projects API from public documentation, as those endpoints are available to Cognite and resellers only.
Time series
Added- Beta support for time zone aware aggregate queries. Align aggregates with a given time zone. Also works with half-hour offsets like Asia/Kolkata (UTC+5:30). Takes DST transitions into account.
- Beta support for new
month(mo) granularity. - Also applies to synthetic time series.
Groups
Added- Introduce the option to manage members of a group through CDF instead of through external groups in the identity provider. This is done through the new
membersfield on the group object. Members can either be explicitly enumerated or one declare a group to include all users accounts. The latter is useful if one wants all existing users and new users who joins a project to automatically receive certain capabilities.
Engineering diagrams (beta)
Added- Beta endpoint for retrieving ocr data for a file per page. Currently, only files that have been run through diagram/detect will give any results. This may be up for change in the future. The endpoint replaces a previous playground endpoint which is no longer documented.
Default runtime in Cognite functions
Changed- Default Python runtime in Cognite functions has been updated from Python 3.8 (py38) to Python 3.11 (py311) in response to the upcoming end of community support for Python 3.8 in October 14, 2024.
Files
Updated- Files API rate and concurrency limits have been documented. — Service layer request rate and concurrency limits added — CRUD endpoints request rate, concurrency and items rate limits added — Analytic endpoints request rate, concurrency rate limits added
Assets
Updated- Assets API rate and concurrency limits have been documented. — Service layer request rate and concurrency limits added — CRUD endpoints request rate, concurrency and items rate limits added — Analytic endpoints request rate, concurrency and items rate limits added
Data Modeling
Added Conversion between unit types for returned values during filter and query operations.- Trigger conversion by setting the
targetUnitbyexternalIdorunitSystemNameparameters for the data source in a query. - When using filters with unit conversion, the unit for filter value is determined by the corresponding property in the
sourceobject. When querying data in centimeters by settingtargetUniton a property in thesource, the filter value for that property will also be considered to be in centimeters. typing-type.uniton a property in atypingobject is now always the same as the unit for the returned data.- Added
typingto following endpoints:- query
- sync
- aggregate
- search
Time series
Added- Data point subscriptions reaches General Availability (GA).
- Use the new Data point subscriptions feature to configure a subscription to listen to changes in one or more time series (in ingestion order). The feature is intended to be used where data points consumers need to keep up to date with changes to one or more time series without the need to read the entire time series again.
Hosted Extractors
Changedhostin kafka sources has been replaced withbootstrapBrokers, which is an array of objects withhostandport.
Synthetic time series
Added- Support for unit conversion by setting
targetUnitortargetUnitSystemon time series or aggregates with a compatibleunitExternalIdfield.
Sessions
Added- Support for creating one-shot sessions by setting the
oneshotTokenExchangeflag. One-shot sessions are short-lived sessions that are not refreshed and do not require support for token exchange from the identity provider.
Data Modeling
Added- Units catalog support for container properties: You can now specify a unit from CDF units catalog on
float32andfloat64properties in containers.
Time series
Changed- Data point subscriptions list data (beta) now supports long polling through the
pollTimeoutSecondsparameter. The request will be kept active for the specified number of seconds, or until new data is available, whichever comes first.
Time series
Added- Units catalog support to time series. This comes in addition to the existing free-text unit field.
- Create timeseries with a unitExternalId.
- Update timeseries to add/remove unitExternalId.
- Filter and aggregate time series by unitExternalId or unitQuantity (eg. “volume” or “temperature”). Both using regular filters and advanced filters.
- Added unit conversion support to retrieve data points/aggregates and retrieve latest. Specify a targetUnit or targetUnitSystem to convert the data points or aggregates to a different unit, or to the default unit of a given unit system.
Hosted extractors
Changed- Hosted extractors API (Beta)
- Updates hosted extractor schema with tls certificate details hence users can now provide CA and authentication certificates for connection to MQTT brokers.
- Now includes schema requirements for connection to Kafka brokers i.e. connection to and extraction from Kafka brokers to Cognie Data fusion is not possible.
Units Catalog
Added- Added the Units Catalog API. The Units Catalog is a collection of units of measurement and their conversion factors. The Units Catalog is used within Cognite Data Fusion to easily convert between different units and unit systems when retrieving Time Series and Data Models.
Documents
Added- Added support for sorting in the
/documents/listendpoint. It works exactly the same as the sorting in/documents/searchexcept that you can not sort on search relevance.
Engineering diagrams
Changed- Optional token mechanism for accessing detected results of engineering diagrams without read all access to assets. See diagram/detect for details.
Files
Added- Added multipart upload endpoints for the files API. This enables upload of files larger than 5 GiB, in a uniform way for all CDF cloud environments.
Optionally use parallel part upload, for greater upload speed.
See the documentation for the new endpoints at:
- Upload multipart file and
- Complete multipart upload endpoints.
Events
Added- New and old but previously undocumented API rate and concurrency limits have been documented.
Overrides have been specified for existing customers, so that the new limits would not affect them.
- Service layer request rate and concurrency limits added.
- CRUD endpoints request rate and concurrency and items rate limits added
Entity matching
Added- Entity matching pipelines are now in v1. We resuscitated the old playground API and made some changes. We will keep the new v1 API in beta for the foreseeable future.
Vision (Contextualization)
Added- New computer vision models (beta) are available in Vision extract service, including digital, dial and level gauge readers, valve state detection (open/closed) and model to segment objects in images.
Hosted extractors
Added- Hosted extractors API (Beta)
- Use the new Hosted extractors feature to create simple streaming extractors running inside CDF, streaming data from sources available on the internet directly into CDF. Currently supports Azure Event Hub and MQTT. Support is planned for Kafka and REST APIs.
3D
Changed- If the 3d model processing is ongoing or has failed, the 3d api nodes endpoints will now return error code 400 with the response body “Revision processing is not yet complete” or “Revision processing failed” respectively. The previous behavior was to return an empty or partial items list in these cases. Before calling any 3d api nodes endpoints, clients should check that the model revision has “status”:“Done”.
Transformations
Changed- Fixed wrong description for fields in “transformations/update” and “/transformations/schedules/update”
Time series
Added- Data point subscriptions (Beta)
- Use the new Data point subscriptions feature to configure a subscription to listen to changes in one or more time series (in ingestion order). The feature is intended to be used where data points consumers need to keep up to date with changes to one or more time series without the need to read the entire time series again. (Beta)
Time series
Added- Advanced query language support reaches General Availability (GA).
- Advanced search, filtering, and sorting capabilities in the Filter time series endpoint.
- Advanced aggregation capabilities in the Aggregate time series endpoint.
Sequences
Added- Advanced query language support reaches General Availability (GA).
- Advanced search, filtering, and sorting capabilities in the Filter sequences endpoint.
- Advanced aggregation capabilities in the Aggregate sequences endpoint.
Assets
Added- Advanced query language support reaches General Availability (GA).
- Advanced search, filtering, and sorting capabilities in the Filter assets endpoint.
- Advanced aggregation capabilities in the Aggregate assets endpoint.
Events
Added- Advanced query language support reaches General Availability (GA).
- Advanced search, filtering, and sorting capabilities in the Filter events endpoint.
- Advanced aggregation capabilities in the Aggregate events endpoint.
Documents
Added- Advanced query language support reaches General Availability (GA).
- Advanced aggregation capabilities in the Aggregate documents endpoint.
IAM (Identity and access management)
Changed-
Identity providers (IdP) are required to be compatible with the OpenID Connect Discovery 1.0 standard, and compliance will now be enforced by the Projects API.
- The
oidcConfiguration.jwksUrlandoidcConfiguration.tokenUrlcan be entirely omitted when updating the OIDC configuration for a project. - The
oidcConfiguration.jwksUrlandoidcConfiguration.tokenUrlare preserved for backwards compatibility of the API. However, if these are specified as part of the request body, the value must match excatly the values that are specified in the OpenID provider configuration document for the configured issuer (can be found athttps://{issuer-url}/.well-known/openid-configuration). If the values does not match, the API will return an error message.
- The
-
The
oidcConfiguration.skewMshas been deprecated but remains part of the API for backwards compatibility. It can be omitted from the request. If included, it must always be set to0. -
The
oidcConfiguration.isGroupCallbackEnabledhas been deprecated but remains part of the API for backwards compatibility. It can be omitted from the request.- For projects configured to use Azure Active Directory as the identity provider, if this value is specified in the request, it must always be set to
true.
- For projects configured to use Azure Active Directory as the identity provider, if this value is specified in the request, it must always be set to
Data Modeling
Added- Added support for an
autoCreateDirectRelationsoption on the endpoint for ingesting instances. This option lets the user specify whether to create missing target nodes of direct relations.
- Removed support for the deprecated per-item
sourcesfield on the/instances/byidsendpoint.
Transformations
Removed- Removing support for authentication via API keys when creating or updating transformations.
Annotations
Added- Added
image.InstanceLinkanddiagrams.InstanceLinkannotation types to allow you to link from objects discovered in images and engineering diagrams to data model instances.
All resources
Added- Added information about Requests throttling.
- Updated the Parallel retrieval documentation.
- Aligned endpoint naming within Assets, Data sets, Events, and Files.
Assets
Added- Added advanced query language support (Beta).
- Advanced search, filtering, and sorting capabilities in the Filter assets endpoint.
- Advanced aggregation capabilities in the Aggregate assets endpoint.
Events
Added- Added advanced query language support (Beta).
- Advanced search, filtering, and sorting capabilities in the Filter events endpoint.
- Advanced aggregation capabilities in the Aggregate events endpoint.
Documents
Added- Added advanced query language support (Beta).
- Advanced aggregation capabilities in the Aggregate documents endpoint.
Sessions
Fixed-
Fixed the API documentation for the request body of the POST /projects//sessions/byids endpoint.
The documentation incorrectly stated the request body schema as specifying the list of session IDs to retrieve, in the form
{"items": [42]}- it should in fact be{"items": [{"id": 42}]}. The documentation has been updated to reflect this. -
Fixed the API documentation for the response body of the POST /projects//sessions/byids endpoint.
The documentation incorrectly stated
nextCursorandpreviousCursorfields as being returned from the response, which was not the case, and these fields have now been removed from the API documentation.
Transformations
Change- Transformations support new target types for view-centric data model instances.
- Added target types
nodesandedges.
Documents
Change- Renamed “approximateCardinality” aggregate to “cardinalityValues” to unify the search spec in Cognite.
- “uniqueProperties” aggregate no longer supports pagination. It returns unique properties (up to 10000) in the specified path. The results are sorted by frequency.
- Added “allUniqueProperties” aggregate that returns all unique properties. The response contains a cursor that can be used to fetch all pages of data.
Seismic
Added- Batch downloading of seismics as a ZIP archive is now an experimental v1 endpoint. A user requires the experimental ACL to use this endpoint, and any other ACLs and scopes to read the downloadable seismics.
- The documentation for downloading seismics as SEG-Y files is part of v1. The API documentation didn’t reflect that the endpoint had been promoted to version 1.
Documents
Added- Added
highlightfield in thesearchendpoint to indicate whether matches in search results should be highlighted.
Documents
Added- Added the search leaf filter, to allow filtering by searching through specified properties.
Documents
Added- Added the uniqueProperties aggregation, which can be used to find all the metadata keys in use.
Documents
Added- Added inAssetSubtree filter to filter documents that have a related asset in a subtree rooted at any of the specified IDs.
Time series
Changed- Timestamps of data points may now be as large as 4102444799999 (23:59:59.999, December 31, 2099). The previous limit was the year 2050.
Transformations
Added- Added capability to run a transformation with Nonce credentials provided through the Run endpoint.
Time series
Changed- Updated datapoints timestamp range from 1971 - 2050 to 1900 - 2050. Affected endpoints:
Documents
Added- Added the
POST /documents/aggregateendpoint. The endpoint allows you to count documents optionally grouped by a property and also to retrieve all unique values of a property.
Documents
Added- Added the
POST /documents/listendpoint. The endpoint allows you to iterate through all the documents in a project. - Added the
POST /documents/{documentId}/contentendpoint. The endpoint lets you download the entire extracted plain text of a document.
Documents
Added- Added the GET /documents//preview/image/pages/ endpoint.
- Added the GET /documents//preview/pdf endpoint.
- Added the GET /documents//preview/pdf/temporarylink endpoint.
Sequences
Changed- Changed sequences column limits. Old limit of maximum total 200 columns limits is updated to maximum 400 total columns, maximum 400 numeric columns and maximum 200 string columns.
Time series
Changed- Marked
isStepparameter to be editable (i.e. removed description stating it is not updatable) in POST /timeseries/create.
- Added
isStepparameter to theTimeSeriesPatchobject used in POST /timeseries/update
Time series
Added- Added optional
ignoreUnknownIdsparameter to POST /sequences/delete. Setting this to true will prevent the operation from failing if one or more of the given sequences do not exist; instead, those given sequences that do exist will be deleted.
Transformations
Added- New Transformations APIs to v1 to create,retrieve,list and delete transformations
- New Transformation Jobs APIs to v1 to retrieve and list transformation jobs or job metrics
- New Transformation Schedule APIs to v1 to manage schedules of transformations
- New Transformation Notifications APIs to v1 to manage notifications from transformation job
Contextualization
Added- Added diagram detect endpoint to v1 to detect annotations in engineering diagrams
- Added diagram detect results endpoint to v1 to get the results from an engineering diagram detect job
- Added diagram convert endpoint to v1 to create interactive engineering diagrams in SVG format with highlighted annotations
- Added diagram convert results endpoint to v1 to get the results for a job converting engineering diagrams to SVGs
Raw
Changed- To align with Microsoft Azure clusters, table and database names are now sensitive to trailing spaces also in Google Cloud Platform clusters.
Extraction Pipelines
Added- New Extraction Pipelines resource to document extractors and monitor the status of data ingestion to make sure reliable and trustworthy data are flowing into the CDF data sets.
- API endpoints for creating, managing, and deleting extraction pipelines. Capture common attributes around extractors such as owners, contacts, schedule, destination RAW databases, and data set. Document structured metadata in the form of key-value attributes as well unstructured
documentationattribute that supports Markdown (rendered as Markdown in Fusion). - Extraction Pipelines Runs are CDF objects to store statuses related to an extraction pipeline. The supported statuses are:
success,failureandseen. They enable extractor developers to report status and error message after ingesting data. As well enables for reporting heartbeat throughseenstatus by the extractor to easily identify issues related to crushed applications and scheduling issues.
Sequences
Added- Added
partitionparameter to the GET /sequences endpoint to support parallel retrieval. - POST /sequences/list now supports parallel retrieval.
Time series
Added- Added
partitionparameter to the GET /timeseries endpoint to support parallel retrieval.
Sequences
Added- Added syntax for updating columns of existing sequences. Can
removecolumns,modifyexisting columns, andaddnew columns as well.
Time series
**Changed granularity limits on hour aggreagatesYou can now ask for a granularity of up to 100000 hours (previously 48 hours), both in normal aggregates and in synthetic time series.IAM (Identity and access management)
Added- Added a projects list endpoint to v1
- Added a token inspection endpoint to v1
Authentication
DeprecatedWe are deprecating authentication via CDF service accounts and API keys, and user sign-in via/login, in favor of registering applications and services with your IdP (identity provider) and using OpenID Connect and the IdP framework to manage CDF access securely.The legacy authentication flow is available for customers using Cognite Data Fusion (CDF) on GCP until further notice. We strongly encourage customers to adopt the new authentication flows as soon as possible.The following API endpoints are deprecated:/api/v1/projects/*/apikeys/api/v1/projects/*/serviceaccounts/login/logout/api/v1/projects/*/groups/serviceaccounts*
CDF API 0.5, 0.6 reached their end-of-life after its initial deprecation announcement in Summer 2019.
3D
Added- Added
partitionparameter to the List 3D Nodes endpoint for supporting parallel requests. - Added
sortByNodeIdparameter to the List 3D Nodes endpoint, improving request latency in most cases if set totrue.
Entity Matching
Fixed- Fixed a bug in the documentation for Entity matching. The (job)
statusshall be capitalized string.
Files
Added- New field
fileTypeinsidederivedFieldsto refer to a pre-defined subset of MIME types. - New filter
fileTypeinsidederivedFieldsto find files with a pre-defined subset of MIME types.
Files
Added- New field
geoLocationto refer to the geographic location of the file. - New filter
geoLocationto find files matching a certain geographic location.
Files
Added- New field
directoryreferring to the directory in the source containing the file. - New filter
directoryPrefixallows you to find Files matching a certain directory prefix.
Files
Added- New field
labelsallows you to attach labels to Files upon creation or updating. - New filter
labelsallows you to find Files that have been annotated with specific labels.
Events
Added- New aggregation
uniqueValuesallows you to find different types, subtypes of events in your project.
Labels
Added- New data organization resource: labels. Manage terms that you can use to annotate and group assets.
Assets
Added- New filter
labelsallows you to find resources that have been annotated with specific labels.
Time series
Added- Combine various input time series, constants and operators with on-the-fly synthetic time series.
Events
Added- New filtering capabilities to find open events
endTime=null. - New filtering capabilities to find all events intersecting a timespan using activeAtTime.
General
Added- New data organization resource: data sets. Document and track data lineage, ensure data integrity, and allow 3rd parties to write their insights securely back to your Cognite Data Fusion (CDF) project.
- New attribute
datasetIdintroduced in assets, files, events, time series and sequences. - New filter
dataSetIdsallows you to narrow down results to resources containingdatasetIdby a list of ids or externalIds of a data set. Supported by assets, files, events, time series and sequences. - We have added a new aggregation endpoint for time series. With this endpoint, you can find out how many results in a tenant meet the criteria of a filter. We will expand this feature to add more aggregates than
count.
Groups
Added- Introduced a new capability:
datasetsAclfor managing access to data set resources. - New scope
datasetScopefor assets, files, events, time series and sequences ACLs. Allows you to scope down access to resources contained within a specified set of data sets.
3D
Fixed- We fixed a bug in the documentation of 3D model revisions. Applications should anticipate that 3D nodes may not have a bounding box.
Assets
Added- We have added a new aggregation endpoint for assets. With this endpoint, you can find out how many assets in a tenant meet the criteria of a filter. We will expand this feature to add more aggregates than
count.
Events
Added- We have added a new aggregation endpoint for events. With this endpoint, you can find out how many events in a tenant meet the criteria of a filter. We will expand this feature to add more aggregates than
count.
Assets
Added- We have added new aggregation properties:
depthandpath. You can use the properties in the filter and retrieve endpoints.
Assets
Added- Added the property
parentExternalIdwhich is returned for all assets which have a parent with a definedexternalId.
General
Added- Added
assetSubtreeIdsas a parameter to filter, search, and list endpoints for all core resources.assetSubtreeIdsallows you to specify assets that are subtree roots, and then only retrieve resources that are related to assets within those subtrees.
Assets
Added- Asset search now has a
search.queryparameter. This uses an improved search algorithm that tries a wider range of variations of the input terms and gives much better relevancy ranking than the existingsearch.nameandsearch.descriptionfields.
Time Series
Changed- The
search.queryparameter for time series search now uses an improved search algorithm that tries a wider range of variations of the input terms, and gives much better relevancy ranking.
Time Series
Added-
Time series expanded their filtering capabilities with new
Filter time seriesendpoint, allowing for additional filtering by:- Name
- Unit
- Type of time series: string or step series
- Metadata objects
- ExternalId prefix filtering
- Create and last updated time ranges
3D
Added- Added endpoint to get multiple nodes for a 3D model by their IDs.
- Added endpoint to get asset mappings for multiple node IDs or asset IDs.
Files
Added- Added support for filter on
rootAssetIdsin files GET /files (using query parameter) and POST /files/list (in request body).
3D
Added- Added the query parameter
intersectsBoundingBoxto the list asset mappings endpoint. The parameter filters asset mappings to the assets where the bounding box intersects (or is contained within) the specified bounding box.
Files
Added- Added support for sourceCreatedTime and sourceModifiedTime fields in files v1 endpoints.
Assets
Added- Allow the parent asset ID to be updated. The root asset ID must be preserved, and you can not convert a non-root asset to a root asset or vice versa.
- Support for ignoreUnknownIds when deleting assets.
3D
Added- Properties field for 3D nodes, extracted from uploaded 3D files.
- Ability to filter nodes with a specific set of properties.
Files
Changed- Allow lookup of names with length up to 256 characters (was 50) for GET /files and POST /files/search operations.
- Allow creating and retrieving files with mimeType length up to 256 characters (was 64).
Time series
Added- Added query parameter
rootAssetIdsto list time series endpoint. Returns time series that are linked to an asset that has one of the root assets as an ancestor.
2019-07-11
Stable
List of changes for initial API v1 release in comparison to previous version - API 0.5
General
Added- Support for
externalIdadded across resource types.externalIdlets you define a unique ID for a data object. Learn more: External IDs externalIdPrefixadded as a parameter to the list events, assets and files operations.- Richer filtering on the list assets, files and events operations.
- Search, list and filter operations for assets, events and files now support filtering on source and metadata field values.
- Core resources standardize on HTTP methods and URI naming for common operations such as search, partial updates, delete, list and filter
- API responses are no longer wrapped in a top level
dataobject. - Standardized pagination across resources through
limit,cursorandnextCursorparameters. - The
limitparameter no longer implicitly rounds down requested page size to maximum page size. - Standardized error responses and codes across all resources. Errors across CDF can be parsed into a single model.
- Overall improvements to reference documentation. Including documented input constraints, required fields, individual attribute descriptions.
- The
sourceIdfield has been removed from resources. UseexternalIdinstead ofsourceId+sourceto define unique IDs for data objects. - Sorting is removed from the search operations for files, assets, events and time series. Results are sorted by relevance.
offsetandpreviousCursorparameters are no longer supported for pagination across resources.- Fetching an asset subtree is no longer supported by files, assets, events and time series.
Assets
Added- Ability to select only root assets though new
rootfilter. - Added the
rootIdfield to specify the top element in an asset hierarchy. - Added the ability to filter by the root asset ID. This allows you to scope queries for one or many asset hierarchies.
- List Assets allows for filtering assets belonging to set of root assets, specified by list of asset internal ids. New query parameter:
rootIds. - Filter and Search Assets allows or filtering assets belonging to a set of root assets, specified by combination of internal and external asset identifiers. New body attribute:
rootIds.
- Updating a single asset is no longer supported through a separate endpoint. Use the update multiple endpoint instead.
- Delete assets by default removes only leaf assets (assets without children). New parameter ‘recursive’ allows for enabling recursive removal of the entire subtree of the asset pointed by ID (API 0.5 behaviour).
- Overwriting assets is no longer supported.
- Filtering assets by their complete description is no longer supported.
- Locating assets fuzzily by name has been removed. Instead, search for assets on the
nameproperty. - When searching assets, querying over both name and description in the same query is no longer supported.
- The experimental query parameter
boostNamehas been removed from the search for assets operation. - Removed the
pathanddepthfields.
Events
Added- Events can now be filtered on asset ID in combination with other filters.
- New filter
rootAssetIdsallows for narrowing down events belonging only to list or specified root assets. Supported by Filter and Search API
- Events can no longer be filtered by empty description.
- The ‘dir’ parameter has been removed from the search events operation.
Files
Added- Filtering files by
assetIdsin list files operations now support multiple assets in the same request.
- Download file content has changed from HTTP GET to HTTP POST method.
- We have renamed the
fileTypefield tomimeType. The field now requires a MIME formatted string (e.g.text/plain). - We have renamed the
uploadedAtfield touploadedTime. - Resumable is now the default behavior for file uploads.
- Update metadata for single files is no longer supported by a separate operation. Instead, use the update multiple operation.
- Replace files metadata endpoint has been removed.
- Directory has been removed as a property of files.
- Updating the
nameormimeTypeof a file through the update multiple files operation is no longer supported. - Query parameter for specifying the sort direction has been removed from list all files operations.
Raw
Changed- Raw has changed structure to become resource-oriented. The URL structure has changed.
- Recursively delete of tables and rows when deleting a database is now the default behavior without a control parameter.
Time series
Added- Support for adding datapoints by
idandexternalIdof time series. Adding datapoints to time series bynamehas been removed. - Add ability to update the new
externalIdattribute for time series. - Allow to set
externalIdduring creation of time series.ExternalIdrequires uniqueness across time series. - Consolidate multiple APIs to allow adding datapoints into a single endpoint. Allows datapoints to be added to multiple time series at the same time.
- Retrieve data points by using
idandexternalIdof the time series. - Time series created through API v1 are not discoverable by API 0.3, 0.4, 0.5 and 0.6 by default. Introduce the option to enable this compatibility by setting new attribute -
legacyNameon time series creation. Value is required to be unique.
- Get latest datapoints has been reworked. Introduces support for
idandexternalIdlookup as well retrieval for multiple time series within the same request. - Time series name is no longer limited by uniqueness. Note that time series (meta objects) created by API v1 will not be discoverable by older API versions.
- Delete time series endpoint has been redesigned to allow deletion of multiple time series by
idandexternalId. - Delete single and multiple datapoints endpoint has been redesigned and consolidated into a single endpoint. New delete allows selection of multiple time series and time ranges by
idandexternalId. Selecting bynameis no longer available. - Update multiple time series restructured to support lookup by
externalId. - Retrieve time series by ID endpoint restructured adding the ability to get time series by
externalId. - Set limit for data point value to min -1E100, max 1E100.
- Experimental feature for performing calculations across multiple time series (synthetic time series), function and alias attributes are no longer available.
- The experimental query parameter
boostNamehas been removed from search operation. - Short names for aggregate functions are no longer supported.
- Ability to remove time series by
namehave been removed as names are no longer unique identifiers. - Select multiple time series and time ranges by
nameis no longer available. - The ability to update
isStringandisStepattributes is removed. The attributes are not intended to be modified after creation of time series. - The endpoint for updating single time series is removed. Use the update multiple time series endpoint instead.
- Remove ability to overwrite time series object by
id. Use the update multiple time series endpoint instead. - The ability to retrieve time series matching by
namehas been removed. UseexternalIdinstead. - The ability to retrieve by
idfrom a single time series has been removed. Use retrieve multiple datapoints for multiple time series instead. - The ability to retrieve time-aligned datapoints through “dataframe” API has been removed. Similar functionality is available through our supported SDKs.
- The ability to add datapoints to time series by
namehas been removed. - The ability to look up by time series
namehas been removed.
IAM (Identity and access management)
Added- The login status endpoint includes the ID of the API key making the request (new attribute:
apiKeyId), if the request used an API key.
- The user resource type has been replaced with service accounts. Users from previous API versions are equivalent to service accounts.
- Adding, listing and removing users from a group has been replaced by equivalent operations for service accounts.
- Retrieve project returns a single object instead of a list.
- API keys endpoints for list/create rename
userIdattribute toserviceAccountId.
- List and create groups no longer use the
permissionsandsourceattributes.
3D
Added- New 3D API lets you upload and process 3D models. Supported format: FBX.
- Ability to create and maintain multiple revisions for the 3D models.
- API for mapping relationships between 3D model nodes and asset hierarchy.